
\name{s22aa}
\alias{s22aa}

\title{s22aa: Legendre functions of 1st kind P_n^m(x) or overlineP_n^m(x)}

\description{
s22aa returns a sequence of values for either the unnormalized or normalized 
Legendre functions of the first kind \eqn{{P}_{{n}}^{{m}}\left({x}\right)}{P_n^m(x)} 
or \eqn{\overline{{P}_{{n}}^{{m}}}\left({x}\right)}{overlineP_n^m(x)} for 
real \eqn{{x}}{x} of a given order \eqn{{m}}{m} and degree \eqn{{n} = {0} 
, {1} , \ldots , {N}}{n = 0 , 1 ,  . . .  , N}.

}

\usage{
s22aa(mode, x, m, nl)
}

\arguments{

\item{mode}{integer

Indicates whether the sequence of function values is to be returned unnormalized 
or normalized. 

\eqn{mode = {1}}{mode = 1}: The sequence of function values is returned 
unnormalized.

\eqn{mode = {2}}{mode = 2}: The sequence of function values is returned 
normalized.




}
\item{x}{double

The argument \eqn{{x}}{x} of the function.


}
\item{m}{integer

The order \eqn{{m}}{m} of the function.


}
\item{nl}{integer

The degree \eqn{{N}}{N} of the last function required in the sequence.


}
}

\details{
R interface to the NAG Fortran routine S22AAF.}

\value{

\item{P}{double array

The required sequence of function values as follows: 

if \eqn{mode = {1}}{mode = 1}, \eqn{p[{n}]}{p[n]} contains \eqn{{P}_{{n}}^{{m}}\left({x}\right)}{P_n^m(x)} 
for \eqn{{n}={0} \ldots {N}}{n=0  . . .  N};

if \eqn{mode = {2}}{mode = 2}, \eqn{p[{n}]}{p[n]} contains \eqn{\overline{{P}_{{n}}^{{m}}}\left({x}\right)}{overlineP_n^m(x)} 
for \eqn{{n}={0} \ldots {N}}{n=0  . . .  N}.




}
\item{IFAIL}{integer

\eqn{\mathrm{ifail} =0}{ifail =0} unless the function detects an error 
or a warning has been flagged (see the Errors section in Fortran library 
documentation).


}
}

\references{
\url{http://www.nag.co.uk/numeric/FL/nagdoc_fl23/pdf/S/s22aaf.pdf}
}

\author{NAG}

\examples{

ifail<-0

mode<-1

x<-0.5

m<-2

nl<-3

s22aa(mode,x,m,nl)

}

\keyword{math}
\concept{Legendre}
