
#include <R.h>
#include <Rinternals.h>
#include "nag_rwrapper_utils.h"
#include "nagmk23.h"
#ifdef __cplusplus
extern "C" {
#endif
extern void NAG_CALL e04dga_OBJFUN(Integer *MODE, CONST Integer *N,
                                   CONST double X[], double *OBJF,
                                   double OBJGRD[], CONST Integer *NSTATE,
                                   Integer *E04DGF_IUSER,
                                   double E04DGF_RUSER[]);

#ifdef __cplusplus
}
#endif
int wE04DGF_handle_options(SEXP OPTLIST, Integer LWSAV_logicalArray[],
                           Integer IWSAV_integerMatrix[],
                           double RWSAV_doubleMatrix[])
;

/* Length of array to hold error messages, no checks are made to ensure this is large enough */
#define LEN_ERR_MSG 100

void E04DGA_clean_up(double *OBJGRD, double *X, Integer *IWORK, double *WORK,
                     Integer *LWSAV, Integer *IWSAV,
                     double *RWSAV);

SEXP WE04DGF(SEXP N, SEXP OBJFUN, SEXP X, SEXP OPTLIST, SEXP RHO)
{
  Integer IFAIL_integer, IFAIL_EXTRACTION_integer;
  Integer E04DGF_IUSER[4];
  double  E04DGF_RUSER[1];
  SEXP    ans, names;
  Integer nadv, iflag;

  /* Initialize the option arrays */
  Integer IFAIL_initializer_integer = 1;
  char    err_msg[LEN_ERR_MSG];
  char    RNAME_char[6] = "E04DGA";
  Integer RNAME_length = 6;

/*Declare dimension variables for option initializer*/
  Integer LCWSAV_integer;
  if ((strcmp(RNAME_char,
              "E04UFF") == 0) || (strcmp(RNAME_char, "E04UFA") == 0))
    {
      LCWSAV_integer = 5;
    }
  else
    {
      LCWSAV_integer = 1;
    }

  Integer LLWSAV_integer;
  if ((strcmp(RNAME_char,
              "E04NKF") == 0) || (strcmp(RNAME_char, "E04NKA") == 0))
    {
      LLWSAV_integer = 20;
    }
  else
    {
      if ((strcmp(RNAME_char,
                  "E04UGF") == 0) || (strcmp(RNAME_char, "E04UGA") == 0))
        {
          LLWSAV_integer = 20;
        }
      else
        {
          LLWSAV_integer = 120;
        }
    }

  Integer LIWSAV_integer;
  if ((strcmp(RNAME_char,
              "E04NKF") == 0) || (strcmp(RNAME_char, "E04NKA") == 0))
    {
      LIWSAV_integer = 380;
    }
  else
    {
      if ((strcmp(RNAME_char,
                  "E04UGF") == 0) || (strcmp(RNAME_char, "E04UGA") == 0))
        {
          LIWSAV_integer = 550;
        }
      else
        {
          LIWSAV_integer = 610;
        }
    }

  Integer LRWSAV_integer;
  if ((strcmp(RNAME_char,
              "E04NKF") == 0) || (strcmp(RNAME_char, "E04NKA") == 0))
    {
      LRWSAV_integer = 285;
    }
  else
    {
      if ((strcmp(RNAME_char,
                  "E04UGF") == 0) || (strcmp(RNAME_char, "E04UGA") == 0))
        {
          LRWSAV_integer = 550;
        }
      else
        {
          LRWSAV_integer = 475;
        }
    }

/*Declare the parameters for the option initializer*/
  char    *CWSAV_charArray = 0;
  Integer *LWSAV_logicalArray = 0;
  Integer *IWSAV_integerMatrix = 0;
  double  *RWSAV_doubleMatrix = 0;
  Integer CWSAV_dim1 = LCWSAV_integer;
  if (!(CWSAV_charArray = (char *) malloc(CWSAV_dim1*80*sizeof(char))))
    {
      error("Memory allocation error for %s", "CWSAV");
    }
  Integer LWSAV_dim1 = LLWSAV_integer;
  if (!(LWSAV_logicalArray = (Integer *) malloc(LWSAV_dim1*sizeof(Integer))))
    {
      error("Memory allocation error for %s", "LWSAV");
    }
  Integer IWSAV_dim1 = LIWSAV_integer;
  if (!(IWSAV_integerMatrix = (Integer *) malloc(IWSAV_dim1*sizeof(Integer))))
    {
      error("Memory allocation error for %s", "IWSAV");
    }
  Integer RWSAV_dim1 = LRWSAV_integer;
  if (!(RWSAV_doubleMatrix = (double *) malloc(RWSAV_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "RWSAV");
    }

  nag_initializeIntegerMatrix(IWSAV_dim1, 1, IWSAV_integerMatrix);
  nag_initializeDoubleMatrix(RWSAV_dim1, 1, RWSAV_doubleMatrix);
  e04wbf_(RNAME_char, CWSAV_charArray, &LCWSAV_integer, LWSAV_logicalArray,
          &LLWSAV_integer, IWSAV_integerMatrix, &LIWSAV_integer,
          RWSAV_doubleMatrix,
          &LRWSAV_integer, &IFAIL_initializer_integer, RNAME_length,
          80);

  if (IFAIL_initializer_integer != 0)
    {
      sprintf(err_msg, "E04WBF failed with IFAIL = %ld\n",
              (long) IFAIL_initializer_integer);
      error(err_msg);
    } /* Handle options */
  int     unit_num;

  unit_num =
    wE04DGF_handle_options(OPTLIST, LWSAV_logicalArray, IWSAV_integerMatrix,
                           RWSAV_doubleMatrix);
  if (unit_num < 0)
    {
      /* Error opening output file */
      sprintf(
        err_msg,
        "Error opening monitoring file for output, check value for `monitoring file` entry in `optlist`");
      error(err_msg);
    }
  else if (unit_num > 0)
    {
      /* We are using an output file, so need to handle the advisory channel */

      /* Remember the current value */
      iflag = 0;
      x04abf_(&iflag, &nadv);

      /* Set the advisory channel to the output file. Need to do this, otherwise E04DGF sends output to both the
         advisory channel and the output file */
      iflag = 1;
      x04abf_(&iflag, &unit_num);
    }

/*initialization for input variables*/
  int     N_integer;
  if (nag_extractInteger(N, &N_integer))
    {
      error("Integer extraction error for %s", "N");
    }
  double  *X_doubleMatrix = 0;

/*initialization for output variables*/
  int     ITER_integer;
  double  OBJF_double;
  double  *OBJGRD_doubleMatrix = 0;

/*allocation general variables*/
  Integer OBJGRD_dim1 = N_integer;
  if (!(OBJGRD_doubleMatrix = (double *) malloc(OBJGRD_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "OBJGRD");
    }
  Integer X_dim1 = N_integer;
  if (!(X_doubleMatrix = (double *) malloc(X_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "X");
    }

/*initialization for workspace variables*/
  Integer *IWORK_integerMatrix = 0;
  double  *WORK_doubleMatrix = 0;

/*allocation for workspace variables*/
  Integer IWORK_dim1 = N_integer+1;
  if (!(IWORK_integerMatrix = (Integer *) malloc(IWORK_dim1*sizeof(Integer))))
    {
      error("Memory allocation error for %s", "IWORK");
    }
  Integer WORK_dim1 = 13*N_integer;
  if (!(WORK_doubleMatrix = (double *) malloc(WORK_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "WORK");
    }

/*extraction for input variables*/
  if ((IFAIL_EXTRACTION_integer =
         nag_extractDoubleMatrix(1, X_dim1, 1, X, X_doubleMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "X", nrows(X), X_dim1);
        }
      else
        {
          E04DGA_clean_up(OBJGRD_doubleMatrix, X_doubleMatrix,
                          IWORK_integerMatrix, WORK_doubleMatrix,
                          LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "X");
        }
    }

/* Perform some initial checks */
  if (!isEnvironment(RHO))
    {
      error("rho must be an environment");
    }

  /* Convert function pointer funct and rho into a couple of integers and store in IUSER */
  nag_convert_p2i(RHO, &E04DGF_IUSER[0]);
  nag_convert_p2i(OBJFUN, &E04DGF_IUSER[2]);

  /* Call the NAG routine */
  IFAIL_integer = 1;
  e04dga_(&N_integer, e04dga_OBJFUN, &ITER_integer, &OBJF_double,
          OBJGRD_doubleMatrix, X_doubleMatrix, IWORK_integerMatrix,
          WORK_doubleMatrix,
          E04DGF_IUSER, E04DGF_RUSER, LWSAV_logicalArray, IWSAV_integerMatrix,
          RWSAV_doubleMatrix,
          &IFAIL_integer);

  /* Close the monitoring file if one opened */

  if (unit_num > 0)
    {
      IFAIL_integer = 1;
      x04adf_(&unit_num, &IFAIL_integer);

      /* Set the advisory channel back to its previous value */
      iflag = 1;
      x04abf_(&iflag, &nadv);
    }

  /* Error returns from NAG routine */
  if (IFAIL_integer != 0)
    {
      warning(
        "ABNORMAL EXIT from NAG library routine  E04DGF, : IFAIL = %ld\n",
        (long) IFAIL_integer);
    }

/* Get the list of results */
  PROTECT(ans = allocVector(VECSXP, 5));
  SET_VECTOR_ELT(ans, 0, nag_i2r(1, &ITER_integer));
  SET_VECTOR_ELT(ans, 1, nag_d2r(1, &OBJF_double));
  SET_VECTOR_ELT(ans, 2, nag_md2r(1, OBJGRD_dim1, 1, OBJGRD_doubleMatrix));
  SET_VECTOR_ELT(ans, 3, nag_md2r(1, X_dim1, 1, X_doubleMatrix));
  SET_VECTOR_ELT(ans, 4, nag_i2r(1, &IFAIL_integer));
  /* Get names for the list of results */
  PROTECT(names = allocVector(STRSXP, 5));
  SET_STRING_ELT(names, 0, mkChar("ITER"));
  SET_STRING_ELT(names, 1, mkChar("OBJF"));
  SET_STRING_ELT(names, 2, mkChar("OBJGRD"));
  SET_STRING_ELT(names, 3, mkChar("X"));
  SET_STRING_ELT(names, 4, mkChar("IFAIL"));
  setAttrib(ans, R_NamesSymbol, names);
/* Unprotect the ans and names objects */
  UNPROTECT(2);

/*Call the clean-up routine*/
  E04DGA_clean_up(OBJGRD_doubleMatrix, X_doubleMatrix, IWORK_integerMatrix,
                  WORK_doubleMatrix, LWSAV_logicalArray, IWSAV_integerMatrix,
                  RWSAV_doubleMatrix);

  return(ans);
}

void NAG_CALL e04dga_OBJFUN(Integer *MODE, CONST Integer *N, CONST double X[],
                            double *OBJF, double OBJGRD[],
                            CONST Integer *NSTATE, Integer *E04DGF_IUSER,
                            double E04DGF_RUSER[])
{
  SEXP funct, rho, R_fcall, result;
/* Get the pointer to the R environment */
  nag_convert_i2p(&E04DGF_IUSER[0], &rho); /* Get the pointer to the R function */
  nag_convert_i2p(&E04DGF_IUSER[2], &funct);

/* Give the arguments to the function */
  PROTECT(R_fcall = lang5(
            funct,
            nag_fi2r(1, MODE),
            nag_fi2r(1, N),
            nag_md2r(1, *N, 1, X),
            nag_fi2r(1, NSTATE)));

/* Get the results from evaluating the function in R */
  PROTECT(result = eval(R_fcall, rho));
/* put the results returned by function into C variables */
  (void) nag_getIntFromList("MODE", result, MODE);
  (void) nag_getDoubleScalarFromList("OBJF", result, OBJF);
  (void) nag_getDoubleMatrixFromList("OBJGRD", 1, *N, 1, result, OBJGRD);

/* Release R_fcall */
  UNPROTECT(2);
}

int wE04DGF_handle_options(SEXP OPTLIST, Integer LWSAV_logicalArray[],
                           Integer IWSAV_integerMatrix[],
                           double RWSAV_doubleMatrix[])
{
  SEXP       names, tentry;
  char       err_msg[LEN_ERR_MSG];
  int        i, ival;
  Integer    INFORM_setter_integer, STR_length;
  double     dval;
  const char *this_name;
  char       STR_char[100];
  int        unit_num = 0;

  /* No options specified */
  if (!isNewList(OPTLIST))
    {
      return 0;
    }

  /* Get the list of names from the list */
  PROTECT(names = getAttrib(OPTLIST, R_NamesSymbol));
  for (i = 0; i < length(OPTLIST); i++)
    {
      this_name = CHAR(STRING_ELT(names, i));

      /* Only interested in the first element, which is what asReal should
         convert to a double */
      PROTECT(tentry = VECTOR_ELT(OPTLIST, i));
      if (!isString(tentry))
        {
          dval = asReal(tentry);
          if (!R_FINITE(dval)) dval = 0.0;
          ival = (int) dval;
        }
      else
        {
          dval = -1.0;
          ival = -1;
        }

      STR_char[0] = '\0';
      if (!strcmp(this_name, "list"))
        {
          if (ival)
            {
              sprintf(STR_char, "list");
            }
          else
            {
              sprintf(STR_char, "nolist");
            }
        }
      else if (!strcmp(this_name, "Estimated Optimal Function Value"))
        {
          sprintf(STR_char, "Estimated Optimal Function Value = %g", dval);
        }
      else if (!strcmp(this_name, "Function Precision"))
        {
          sprintf(STR_char, "Function Precision = %g", dval);
        }
      else if (!strcmp(this_name, "Iteration Limit"))
        {
          sprintf(STR_char, "Iteration Limit = %d", ival);
        }
      else if (!strcmp(this_name, "Linesearch Tolerance"))
        {
          sprintf(STR_char, "Linesearch Tolerance = %g", dval);
        }
      else if (!strcmp(this_name, "Maximum Step Length"))
        {
          sprintf(STR_char, "Maximum Step Length = %g", dval);
        }
      else if (!strcmp(this_name, "Optimality Tolerance"))
        {
          sprintf(STR_char, "Optimality Tolerance = %g", dval);
        }
      else if (!strcmp(this_name, "Print Level"))
        {
          sprintf(STR_char, "Print Level = %d", ival);
        }
      else if (!strcmp(this_name, "Verify Level"))
        {
          sprintf(STR_char, "Verify Level = %d", ival);
        }

      /* All other options are ignored (this includes the valid ones: cold start and warm start) */

      UNPROTECT(1);

      /* Call the option setting routine */
      if (STR_char[0])
        {
          INFORM_setter_integer = 1;
          STR_length = strlen(STR_char);
          e04dka_(STR_char, LWSAV_logicalArray, IWSAV_integerMatrix,
                  RWSAV_doubleMatrix, &INFORM_setter_integer,
                  STR_length);

          if (INFORM_setter_integer != 0)
            {
              sprintf(err_msg, "E04DKA failed with IFAIL = %ld\n",
                      (long) INFORM_setter_integer);
              error(err_msg);
            }
        }
    }
  UNPROTECT(1);
  return unit_num;
}

void E04DGA_clean_up(double *OBJGRD, double *X, Integer *IWORK, double *WORK,
                     Integer *LWSAV, Integer *IWSAV,
                     double *RWSAV)
{
  if (OBJGRD) free(OBJGRD);
  if (X) free(X);
  if (IWORK) free(IWORK);
  if (WORK) free(WORK);
  if (LWSAV) free(LWSAV);
  if (IWSAV) free(IWSAV);
  if (RWSAV) free(RWSAV);
  return;
}
