
#include <R.h>
#include <Rinternals.h>
#include "nag_rwrapper_utils.h"
#include "nagmk23.h"
#ifdef __cplusplus
extern "C" {
#endif
extern void NAG_CALL e04xaa_OBJFUN(Integer *MODE, CONST Integer *N,
                                   CONST double X[], double *OBJF,
                                   double OBJGRD[], CONST Integer *NSTATE,
                                   Integer *E04XAF_IUSER,
                                   double E04XAF_RUSER[]);

#ifdef __cplusplus
}
#endif

/* Length of array to hold error messages, no checks are made to ensure this is large enough */
#define LEN_ERR_MSG 100

void E04XAA_clean_up(double *X, double *HFORW, double *OBJGRD, double *HCNTRL,
                     double *H, double *WORK, Integer *INFO, Integer *LWSAV,
                     Integer *IWSAV,
                     double *RWSAV);

SEXP WE04XAF(SEXP MSGLVL, SEXP N, SEXP EPSRF, SEXP X, SEXP MODE, SEXP OBJFUN,
             SEXP HFORW, SEXP LWSAV, SEXP IWSAV, SEXP RWSAV,
             SEXP RHO)
{
  Integer IFAIL_integer, IFAIL_EXTRACTION_integer;
  Integer E04XAF_IUSER[4];
  double  E04XAF_RUSER[1];
  SEXP    ans, names;

  /* Initialize the option arrays */
  Integer IFAIL_initializer_integer = 1;
  char    err_msg[LEN_ERR_MSG];
  char    RNAME_char[6] = "E04XAA";
  Integer RNAME_length = 6;

/*Declare dimension variables for option initializer*/
  Integer LCWSAV_integer;
  if ((strcmp(RNAME_char,
              "E04UFF") == 0) || (strcmp(RNAME_char, "E04UFA") == 0))
    {
      LCWSAV_integer = 5;
    }
  else
    {
      LCWSAV_integer = 1;
    }

  Integer LLWSAV_integer;
  if ((strcmp(RNAME_char,
              "E04NKF") == 0) || (strcmp(RNAME_char, "E04NKA") == 0))
    {
      LLWSAV_integer = 20;
    }
  else
    {
      if ((strcmp(RNAME_char,
                  "E04UGF") == 0) || (strcmp(RNAME_char, "E04UGA") == 0))
        {
          LLWSAV_integer = 20;
        }
      else
        {
          LLWSAV_integer = 120;
        }
    }

  Integer LIWSAV_integer;
  if ((strcmp(RNAME_char,
              "E04NKF") == 0) || (strcmp(RNAME_char, "E04NKA") == 0))
    {
      LIWSAV_integer = 380;
    }
  else
    {
      if ((strcmp(RNAME_char,
                  "E04UGF") == 0) || (strcmp(RNAME_char, "E04UGA") == 0))
        {
          LIWSAV_integer = 550;
        }
      else
        {
          LIWSAV_integer = 610;
        }
    }

  Integer LRWSAV_integer;
  if ((strcmp(RNAME_char,
              "E04NKF") == 0) || (strcmp(RNAME_char, "E04NKA") == 0))
    {
      LRWSAV_integer = 285;
    }
  else
    {
      if ((strcmp(RNAME_char,
                  "E04UGF") == 0) || (strcmp(RNAME_char, "E04UGA") == 0))
        {
          LRWSAV_integer = 550;
        }
      else
        {
          LRWSAV_integer = 475;
        }
    }

/*Declare the parameters for the option initializer*/
  char    *CWSAV_charArray = 0;
  Integer *LWSAV_logicalArray = 0;
  Integer *IWSAV_integerMatrix = 0;
  double  *RWSAV_doubleMatrix = 0;
  Integer CWSAV_dim1 = LCWSAV_integer;
  if (!(CWSAV_charArray = (char *) malloc(CWSAV_dim1*80*sizeof(char))))
    {
      error("Memory allocation error for %s", "CWSAV");
    }
  Integer LWSAV_dim1 = LLWSAV_integer;
  if (!(LWSAV_logicalArray = (Integer *) malloc(LWSAV_dim1*sizeof(Integer))))
    {
      error("Memory allocation error for %s", "LWSAV");
    }
  Integer IWSAV_dim1 = LIWSAV_integer;
  if (!(IWSAV_integerMatrix = (Integer *) malloc(IWSAV_dim1*sizeof(Integer))))
    {
      error("Memory allocation error for %s", "IWSAV");
    }
  Integer RWSAV_dim1 = LRWSAV_integer;
  if (!(RWSAV_doubleMatrix = (double *) malloc(RWSAV_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "RWSAV");
    }

  nag_initializeIntegerMatrix(IWSAV_dim1, 1, IWSAV_integerMatrix);
  nag_initializeDoubleMatrix(RWSAV_dim1, 1, RWSAV_doubleMatrix);
  e04wbf_(RNAME_char, CWSAV_charArray, &LCWSAV_integer, LWSAV_logicalArray,
          &LLWSAV_integer, IWSAV_integerMatrix, &LIWSAV_integer,
          RWSAV_doubleMatrix,
          &LRWSAV_integer, &IFAIL_initializer_integer, RNAME_length,
          80);

  if (IFAIL_initializer_integer != 0)
    {
      sprintf(err_msg, "E04WBF failed with IFAIL = %ld\n",
              (long) IFAIL_initializer_integer);
      error(err_msg);
    }
/*initialization for input variables*/
  int     MSGLVL_integer;
  if (nag_extractInteger(MSGLVL, &MSGLVL_integer))
    {
      error("Integer extraction error for %s", "MSGLVL");
    }
  int     N_integer;
  if (nag_extractInteger(N, &N_integer))
    {
      error("Integer extraction error for %s", "N");
    }
  double  EPSRF_double;
  if (nag_extractDouble(EPSRF, &EPSRF_double))
    {
      error("Double extraction error for %s", "EPSRF");
    }
  double  *X_doubleMatrix = 0;
  int     MODE_integer;
  if (nag_extractInteger(MODE, &MODE_integer))
    {
      error("Integer extraction error for %s", "MODE");
    }
  double  *HFORW_doubleMatrix = 0;

/*initialization for dimension variables*/
  Integer LDH_integer = N_integer;

/*initialization for output variables*/
  double  OBJF_double;
  double  *OBJGRD_doubleMatrix = 0;
  double  *HCNTRL_doubleMatrix = 0;
  double  *H_doubleMatrix = 0;
  int     IWARN_integer;
  Integer *INFO_integerMatrix = 0;

/*allocation general variables*/
  Integer X_dim1 = N_integer;
  if (!(X_doubleMatrix = (double *) malloc(X_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "X");
    }
  Integer HFORW_dim1 = N_integer;
  if (!(HFORW_doubleMatrix = (double *) malloc(HFORW_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "HFORW");
    }
  Integer OBJGRD_dim1 = N_integer;
  if (!(OBJGRD_doubleMatrix = (double *) malloc(OBJGRD_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "OBJGRD");
    }
  Integer HCNTRL_dim1 = N_integer;
  if (!(HCNTRL_doubleMatrix = (double *) malloc(HCNTRL_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "HCNTRL");
    }
  Integer H_dim1 = LDH_integer;
  Integer H_dim2;
  if ((MODE_integer == 0))
    {
      H_dim2 = 1;
    }
  if ((MODE_integer == 1) || (MODE_integer == 2))
    {
      H_dim2 = N_integer;
    }
  if (!(H_doubleMatrix = (double *) malloc(H_dim1*H_dim2*sizeof(double))))
    {
      error("Memory allocation error for %s", "H");
    }
  Integer INFO_dim1 = N_integer;
  if (!(INFO_integerMatrix = (Integer *) malloc(INFO_dim1*sizeof(Integer))))
    {
      error("Memory allocation error for %s", "INFO");
    }

/*initialization for workspace variables*/
  double  *WORK_doubleMatrix = 0;

/*allocation for workspace variables*/
  Integer WORK_dim1 = 0;
  if ((MODE_integer == 0))
    {
      WORK_dim1 = N_integer;
    }
  if ((MODE_integer == 1) || (MODE_integer == 2))
    {
      WORK_dim1 = N_integer*(N_integer+1);
    }
  if (!(WORK_doubleMatrix = (double *) malloc(WORK_dim1*sizeof(double))))
    {
      error("Memory allocation error for %s", "WORK");
    }

/*allocation for dimension variables*/

/*extraction for input variables*/
  if ((IFAIL_EXTRACTION_integer =
         nag_extractDoubleMatrix(1, X_dim1, 1, X, X_doubleMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "X", nrows(X), X_dim1);
        }
      else
        {
          E04XAA_clean_up(X_doubleMatrix, HFORW_doubleMatrix,
                          OBJGRD_doubleMatrix, HCNTRL_doubleMatrix,
                          H_doubleMatrix,
                          WORK_doubleMatrix, INFO_integerMatrix,
                          LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "X");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractDoubleMatrix(1, HFORW_dim1, 1, HFORW, HFORW_doubleMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "HFORW", nrows(HFORW), HFORW_dim1);
        }
      else
        {
          E04XAA_clean_up(X_doubleMatrix, HFORW_doubleMatrix,
                          OBJGRD_doubleMatrix, HCNTRL_doubleMatrix,
                          H_doubleMatrix,
                          WORK_doubleMatrix, INFO_integerMatrix,
                          LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "HFORW");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractLogicalVector(LWSAV_dim1, LWSAV, LWSAV_logicalArray)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "LWSAV", nrows(LWSAV), LWSAV_dim1);
        }
      else
        {
          E04XAA_clean_up(X_doubleMatrix, HFORW_doubleMatrix,
                          OBJGRD_doubleMatrix, HCNTRL_doubleMatrix,
                          H_doubleMatrix,
                          WORK_doubleMatrix, INFO_integerMatrix,
                          LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "LWSAV");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractIntegerMatrix(1, IWSAV_dim1, 1, IWSAV, IWSAV_integerMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "IWSAV", nrows(IWSAV), IWSAV_dim1);
        }
      else
        {
          E04XAA_clean_up(X_doubleMatrix, HFORW_doubleMatrix,
                          OBJGRD_doubleMatrix, HCNTRL_doubleMatrix,
                          H_doubleMatrix,
                          WORK_doubleMatrix, INFO_integerMatrix,
                          LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "IWSAV");
        }
    }
  if ((IFAIL_EXTRACTION_integer =
         nag_extractDoubleMatrix(1, RWSAV_dim1, 1, RWSAV, RWSAV_doubleMatrix)))
    {
      if ((IFAIL_EXTRACTION_integer == 3) || (IFAIL_EXTRACTION_integer == 4))
        {
          warning(
            "Dimensions mismatch for %s, matrix is of size %d and the expected size is %d",
            "RWSAV", nrows(RWSAV), RWSAV_dim1);
        }
      else
        {
          E04XAA_clean_up(X_doubleMatrix, HFORW_doubleMatrix,
                          OBJGRD_doubleMatrix, HCNTRL_doubleMatrix,
                          H_doubleMatrix,
                          WORK_doubleMatrix, INFO_integerMatrix,
                          LWSAV_logicalArray,
                          IWSAV_integerMatrix,
                          RWSAV_doubleMatrix);
          error("Array extraction error for %s", "RWSAV");
        }
    }

/* Perform some initial checks */
  if (!isEnvironment(RHO))
    {
      error("rho must be an environment");
    }

  /* Convert function pointer funct and rho into a couple of integers and store in IUSER */
  nag_convert_p2i(RHO, &E04XAF_IUSER[0]);
  nag_convert_p2i(OBJFUN, &E04XAF_IUSER[2]);

  /* Call the NAG routine */
  IFAIL_integer = 1;
  e04xaa_(&MSGLVL_integer, &N_integer, &EPSRF_double, X_doubleMatrix,
          &MODE_integer, e04xaa_OBJFUN, &LDH_integer, HFORW_doubleMatrix,
          &OBJF_double,
          OBJGRD_doubleMatrix, HCNTRL_doubleMatrix, H_doubleMatrix,
          &IWARN_integer,
          WORK_doubleMatrix, E04XAF_IUSER, E04XAF_RUSER, INFO_integerMatrix,
          LWSAV_logicalArray, IWSAV_integerMatrix, RWSAV_doubleMatrix,
          &IFAIL_integer);

  /* Error returns from NAG routine */
  if (IFAIL_integer != 0)
    {
      warning(
        "ABNORMAL EXIT from NAG library routine  E04XAF, : IFAIL = %ld\n",
        (long) IFAIL_integer);
    }

/* Get the list of results */
  PROTECT(ans = allocVector(VECSXP, 9));
  SET_VECTOR_ELT(ans, 0, nag_i2r(1, &MODE_integer));
  SET_VECTOR_ELT(ans, 1, nag_md2r(1, HFORW_dim1, 1, HFORW_doubleMatrix));
  SET_VECTOR_ELT(ans, 2, nag_d2r(1, &OBJF_double));
  SET_VECTOR_ELT(ans, 3, nag_md2r(1, OBJGRD_dim1, 1, OBJGRD_doubleMatrix));
  SET_VECTOR_ELT(ans, 4, nag_md2r(1, HCNTRL_dim1, 1, HCNTRL_doubleMatrix));
  SET_VECTOR_ELT(ans, 5, nag_md2r(1, H_dim1, H_dim2, H_doubleMatrix));
  SET_VECTOR_ELT(ans, 6, nag_i2r(1, &IWARN_integer));
  SET_VECTOR_ELT(ans, 7, nag_mi2r(1, INFO_dim1, 1, INFO_integerMatrix));
  SET_VECTOR_ELT(ans, 8, nag_i2r(1, &IFAIL_integer));
  /* Get names for the list of results */
  PROTECT(names = allocVector(STRSXP, 9));
  SET_STRING_ELT(names, 0, mkChar("MODE"));
  SET_STRING_ELT(names, 1, mkChar("HFORW"));
  SET_STRING_ELT(names, 2, mkChar("OBJF"));
  SET_STRING_ELT(names, 3, mkChar("OBJGRD"));
  SET_STRING_ELT(names, 4, mkChar("HCNTRL"));
  SET_STRING_ELT(names, 5, mkChar("H"));
  SET_STRING_ELT(names, 6, mkChar("IWARN"));
  SET_STRING_ELT(names, 7, mkChar("INFO"));
  SET_STRING_ELT(names, 8, mkChar("IFAIL"));
  setAttrib(ans, R_NamesSymbol, names);
/* Unprotect the ans and names objects */
  UNPROTECT(2);

/*Call the clean-up routine*/
  E04XAA_clean_up(X_doubleMatrix, HFORW_doubleMatrix, OBJGRD_doubleMatrix,
                  HCNTRL_doubleMatrix, H_doubleMatrix, WORK_doubleMatrix,
                  INFO_integerMatrix,
                  LWSAV_logicalArray, IWSAV_integerMatrix,
                  RWSAV_doubleMatrix);

  return(ans);
}

void NAG_CALL e04xaa_OBJFUN(Integer *MODE, CONST Integer *N, CONST double X[],
                            double *OBJF, double OBJGRD[],
                            CONST Integer *NSTATE, Integer *E04XAF_IUSER,
                            double E04XAF_RUSER[])
{
  SEXP funct, rho, R_fcall, result;
/* Get the pointer to the R environment */
  nag_convert_i2p(&E04XAF_IUSER[0], &rho); /* Get the pointer to the R function */
  nag_convert_i2p(&E04XAF_IUSER[2], &funct);

/* Give the arguments to the function */
  PROTECT(R_fcall = lang5(
            funct,
            nag_fi2r(1, MODE),
            nag_fi2r(1, N),
            nag_md2r(1, *N, 1, X),
            nag_fi2r(1, NSTATE)));

/* Get the results from evaluating the function in R */
  PROTECT(result = eval(R_fcall, rho));
/* put the results returned by function into C variables */
  (void) nag_getIntFromList("MODE", result, MODE);
  (void) nag_getDoubleScalarFromList("OBJF", result, OBJF);
  (void) nag_getDoubleMatrixFromList("OBJGRD", 1, *N, 1, result, OBJGRD);

/* Release R_fcall */
  UNPROTECT(2);
}

void E04XAA_clean_up(double *X, double *HFORW, double *OBJGRD, double *HCNTRL,
                     double *H, double *WORK, Integer *INFO, Integer *LWSAV,
                     Integer *IWSAV,
                     double *RWSAV)
{
  if (X) free(X);
  if (HFORW) free(HFORW);
  if (OBJGRD) free(OBJGRD);
  if (HCNTRL) free(HCNTRL);
  if (H) free(H);
  if (WORK) free(WORK);
  if (INFO) free(INFO);
  if (LWSAV) free(LWSAV);
  if (IWSAV) free(IWSAV);
  if (RWSAV) free(RWSAV);
  return;
}
